<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Class: SlingshotSyncController</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <link rel="stylesheet" href=".././rdoc-style.css" type="text/css" media="screen" />
  <script type="text/javascript">
  // <![CDATA[

  function popupCode( url ) {
    window.open(url, "Code", "resizable=yes,scrollbars=yes,toolbar=no,status=no,height=150,width=400")
  }

  function toggleCode( id ) {
    if ( document.getElementById )
      elem = document.getElementById( id );
    else if ( document.all )
      elem = eval( "document.all." + id );
    else
      return false;

    elemStyle = elem.style;
    
    if ( elemStyle.display != "block" ) {
      elemStyle.display = "block"
    } else {
      elemStyle.display = "none"
    }

    return true;
  }
  
  // Make codeblocks hidden by default
  document.writeln( "<style type=\"text/css\">div.method-source-code { display: none }</style>" )
  
  // ]]>
  </script>

</head>
<body>



    <div id="classHeader">
        <table class="header-table">
        <tr class="top-aligned-row">
          <td><strong>Class</strong></td>
          <td class="class-name-in-header">SlingshotSyncController</td>
        </tr>
        <tr class="top-aligned-row">
            <td><strong>In:</strong></td>
            <td>
                <a href="../files/app/controllers/slingshot_sync_controller_rb.html">
                app/controllers/slingshot_sync_controller.rb
                </a>
        <br />
            </td>
        </tr>

        <tr class="top-aligned-row">
            <td><strong>Parent:</strong></td>
            <td>
                SlingshotController
            </td>
        </tr>
        </table>
    </div>
  <!-- banner header -->

  <div id="bodyContent">



  <div id="contextContent">

    <div id="description">
      <p>
Copyright &#169; 2007 Joyent Inc.
</p>
<p>
THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
USE OR OTHER DEALINGS IN THE SOFTWARE.
</p>

    </div>


   </div>

    <div id="method-list">
      <h3 class="section-bar">Methods</h3>

      <div class="name-list">
      <a href="#M000031">aggregate_data</a>&nbsp;&nbsp;
      <a href="#M000032">download_file</a>&nbsp;&nbsp;
      <a href="#M000033">require_http_authentication</a>&nbsp;&nbsp;
      </div>
    </div>

  </div>


    <!-- if includes -->
    <div id="includes">
      <h3 class="section-bar">Included Modules</h3>

      <div id="includes-list">
        <span class="include-name"><a href="AuthenticatedSystem.html">AuthenticatedSystem</a></span>
      </div>
    </div>

    <div id="section">





      


    <!-- if method_list -->
    <div id="methods">
      <h3 class="section-bar">Public Instance methods</h3>

      <div id="method-M000031" class="method-detail">
        <a name="M000031"></a>

        <div class="method-heading">
          <a href="#M000031" class="method-signature">
          <span class="method-name">aggregate_data</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Here is where the bulk of your efffort will go in the down sync portion You
are tasked with creating an array of arrays that will define all the data
which will be available for a particular user while running in offline
mode. This example is simply aggregating all the information for a
particular &#8216;organization&#8217; but you can embed whatever logic that
you need here to send down data with much more fine grained permissions.
You could also, perhaps, delete all the database data from a particular
client if they are no longer allowed access to your service.
</p>
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000031-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000031-source">
<pre>
    <span class="ruby-comment cmt"># File app/controllers/slingshot_sync_controller.rb, line 23</span>
23:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">aggregate_data</span>
24:     <span class="ruby-identifier">model</span> = [<span class="ruby-identifier">current_user</span>]
25:     <span class="ruby-identifier">model</span> <span class="ruby-operator">+=</span> <span class="ruby-constant">Song</span>.<span class="ruby-identifier">find</span>(<span class="ruby-identifier">:all</span>, <span class="ruby-identifier">:conditions</span> =<span class="ruby-operator">&gt;</span> [<span class="ruby-value str">&quot;user_id = ?&quot;</span>, <span class="ruby-identifier">current_user</span>.<span class="ruby-identifier">id</span>])
26:     <span class="ruby-identifier">model</span> <span class="ruby-operator">+=</span> <span class="ruby-constant">Show</span>.<span class="ruby-identifier">find</span>(<span class="ruby-identifier">:all</span>, <span class="ruby-identifier">:conditions</span> =<span class="ruby-operator">&gt;</span> [<span class="ruby-value str">&quot;user_id = ?&quot;</span>, <span class="ruby-identifier">current_user</span>.<span class="ruby-identifier">id</span>])
27:     <span class="ruby-identifier">current_user</span>.<span class="ruby-identifier">shows</span>.<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">s</span><span class="ruby-operator">|</span>
28:       <span class="ruby-identifier">model</span> <span class="ruby-operator">+=</span> <span class="ruby-identifier">s</span>.<span class="ruby-identifier">usages</span>
29:     <span class="ruby-keyword kw">end</span>
30:     <span class="ruby-identifier">puts</span> <span class="ruby-identifier">model</span>.<span class="ruby-identifier">inspect</span>
31:     <span class="ruby-identifier">model</span>
32:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000032" class="method-detail">
        <a name="M000032"></a>

        <div class="method-heading">
          <a href="#M000032" class="method-signature">
          <span class="method-name">download_file</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p>
Not required, but a good place to have a helper method to download a file
using http auth so that you can easily sync down files. When sync happens,
you&#8217;re going to have a user requesting info without having an active
session
</p>
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000032-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000032-source">
<pre>
    <span class="ruby-comment cmt"># File app/controllers/slingshot_sync_controller.rb, line 39</span>
39:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">download_file</span>
40:     <span class="ruby-comment cmt"># Example</span>
41:     <span class="ruby-comment cmt"># @joyent_file = JoyentFile.restricted_find(params[:id])</span>
42:     <span class="ruby-comment cmt">#     send_joyent_file(@joyent_file, true)</span>
43:     <span class="ruby-comment cmt">#   rescue ActiveRecord::RecordNotFound</span>
44:     <span class="ruby-comment cmt">#     redirect_to files_index_url</span>
45:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000033" class="method-detail">
        <a name="M000033"></a>

        <div class="method-heading">
          <a href="#M000033" class="method-signature">
          <span class="method-name">require_http_authentication</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000033-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000033-source">
<pre>
    <span class="ruby-comment cmt"># File app/controllers/slingshot_sync_controller.rb, line 48</span>
48:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">require_http_authentication</span>
49:     <span class="ruby-comment cmt"># Use this to hook into your authentication</span>
50:     
51:     <span class="ruby-keyword kw">unless</span> (<span class="ruby-identifier">auth</span> = (<span class="ruby-identifier">request</span>.<span class="ruby-identifier">env</span>[<span class="ruby-value str">'X-HTTP_AUTHORIZATION'</span>] <span class="ruby-operator">||</span> <span class="ruby-identifier">request</span>.<span class="ruby-identifier">env</span>[<span class="ruby-value str">'HTTP_AUTHORIZATION'</span>])).<span class="ruby-identifier">nil?</span>
52:       <span class="ruby-identifier">auth</span> = <span class="ruby-identifier">auth</span>.<span class="ruby-identifier">split</span>
53:       <span class="ruby-identifier">user</span>, <span class="ruby-identifier">password</span> = <span class="ruby-constant">Base64</span>.<span class="ruby-identifier">decode64</span>(<span class="ruby-identifier">auth</span>[<span class="ruby-value">1</span>]).<span class="ruby-identifier">split</span>(<span class="ruby-value str">':'</span>)[<span class="ruby-value">0</span><span class="ruby-operator">..</span><span class="ruby-value">1</span>]
54:       <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">current_user</span> = <span class="ruby-constant">User</span>.<span class="ruby-identifier">authenticate</span>(<span class="ruby-identifier">user</span>,<span class="ruby-identifier">password</span>)
55:       <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">logged_in?</span>
56:         <span class="ruby-keyword kw">return</span> <span class="ruby-keyword kw">true</span>
57:       <span class="ruby-keyword kw">end</span>
58:     <span class="ruby-keyword kw">end</span>
59:     <span class="ruby-ivar">@response</span>.<span class="ruby-identifier">headers</span>[<span class="ruby-value str">&quot;Status&quot;</span>] = <span class="ruby-value str">&quot;Unauthorized&quot;</span>
60:     <span class="ruby-ivar">@response</span>.<span class="ruby-identifier">headers</span>[<span class="ruby-value str">&quot;WWW-Authenticate&quot;</span>] = <span class="ruby-value str">&quot;Basic realm=\&quot;Offline Sync from Joyent\&quot;&quot;</span>
61:     <span class="ruby-identifier">render</span> <span class="ruby-identifier">:text</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value str">'You must log in to access your Sync'</span>, <span class="ruby-identifier">:status</span> =<span class="ruby-operator">&gt;</span> <span class="ruby-value">401</span>
62:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>


    </div>


  </div>


<div id="validator-badges">
  <p><small><a href="http://validator.w3.org/check/referer">[Validate]</a></small></p>
</div>

</body>
</html>